data segment para public
	fname	db	'image2.prb'
	betu	db	'$'
	xkoord	dw	0
	ykoord	dw	0
	hely	dw	0
	step	dw	1
	fszam	dw	(?)
	hossz	dw	0
	honnan	dw	0
	tomb	db	64000 dup (0)
	sor	dw	0	;ez mondja meg, hogy hanyadik sornal es oszlopnal kezdi kirajzolni a kepet.
	paletta	db	3*256 dup (0)
	xres	dw	320	; kep szelesseg
	yres	dw	200	; kep magassag
	ix	dw	0	;a sprite balfelso sarka
	iy	dw	0
	array	db	64 dup (?)
	sprite	db	0, 0, 0,15, 0, 0, 0, 0
		db	0, 0, 0,15, 0, 0, 0, 0
		db	0, 0, 0,15, 0, 0, 0, 0
		db	15,15,15, 0,15,15,15, 0
		db	0, 0, 0,15, 0, 0, 0, 0
		db	0, 0, 0,15, 0, 0, 0, 0
		db	0, 0, 0,15, 0, 0, 0, 0
		db	0, 0, 0, 0, 0, 0, 0, 0
	maszk	db	00010000b
		db	01010100b
		db	00111000b
		db	11101110b
		db	00111000b
		db	01010100b
		db	00010000b
		db	00000000b
data ends
stack1 segment para stack 'stack'
	verem	dw	256 dup (?)
stack1 ends
kod segment para public 'code'
	assume cs:kod, ds:data, ss:stack1 ;, es:kep
loadfile proc		;open file
	mov	dx, offset fname
	mov	al, 2
	mov	ah, 3Dh
	int	21h
	mov	fszam, ax
	ret
loadfile endp
closefile proc		;colse file
	mov	bx, fszam
	mov	ah, 3Eh
	int	21h
	ret
closefile endp
movepointer proc		;rsi/olvassi mutat eltolsa (CX:DX byte-tal)
	mov	al, 0	;a file kezdettl
	mov	bx, fszam	;melyik file	
	mov	cx, 0	;
	mov	dx, honnan	;mennyivel
	mov	ah, 42h
	int	21h
	ret
movepointer endp
read proc			;file olvassa
	mov	bx, fszam	;melyik file (file kezel)
	mov	cx, hossz	;hny bytot olvasson
	mov	dx, offset tomb	;DS:DX a puffer cme
	mov	ah, 3fh
	int	21h
	ret
read endp
save proc			;file mentse
	mov	bx, fszam	;melyik file
	mov	cx, hossz	;hny bytot
	mov	dx, offset tomb	;DS:DX a kirsra kerl adatok cme
	mov	ah, 40h
	int	21h
	ret
save endp
kirajzol proc
	push	ax
	push	bx
	mov	bx, xkoord
	mov	cl, 6
	shl	bl, cl
	shr	bl, cl
	cmp	bl, 0
	je	kovi
	cmp	bl, 1
	je	p3
	cmp	bl, 2
	je	p2
	cmp	bl, 3
	je	p1
p3:	
	mov	bx, xkoord
	add	bx, 3
	mov	xkoord, bx
	jmp	kovi
p2:	
	mov	bx, xkoord
	add	bx, 2
	mov	xkoord, bx
	jmp	kovi
p1:	
	mov	bx, xkoord
	add	bx, 1
	mov	xkoord, bx
	jmp	kovi
kovi:	
	mov	cx, ykoord
	mov	sor, 3+3*320
ciklus1:
	mov	ax, cx	;
	dec	ax	;
	mov	si, xkoord	;
	mul	si	;
	mov	si, ax	;(cx-1)*xkoord
	add	si, offset tomb
	push	cx
	mov	cx, xkoord
	mov	di, sor
	rep 	movsb       ;ciklus; ds:[si]->es:[di]; si:=si+1; di:=di+1; cx--; end
	pop	cx
	mov	ax, sor
	add	ax, 320
	mov	sor, ax
	loop	ciklus1
	pop	bx
	pop	ax
	ret
kirajzol endp
palette proc
	push	cx
	mov	cx, 256
	mov	di, 54
	mov	si, 0
pcikl:	
	push	cx
	mov	honnan, di
	call	movepointer
	mov	bx, fszam
	mov	cx, 1
	mov	dx, offset betu
	mov	ah, 3fh
	int	21h
	mov	bl, betu
	shr	bx, 1
	shr	bx, 1
	mov	paletta[si+2], bl
	inc	di
	mov	honnan, di
	call	movepointer
	mov	bx, fszam
	mov	cx, 1
	mov	dx, offset betu
	mov	ah, 3fh
	int	21h
	mov	bl, betu
	shr	bx, 1
	shr	bx, 1
	mov	paletta[si+1], bl
	inc	di
	mov	honnan, di
	call	movepointer
	mov	bx, fszam
	mov	cx, 1
	mov	dx, offset betu
	mov	ah, 3fh
	int	21h
	mov	bl, betu
	shr	bx, 1
	shr	bx, 1
	mov	paletta[si+0], bl
	inc	di	;di++
	inc	di
	inc	si
	inc	si
	inc	si
	pop	cx
	loop	pcikl
	mov	ax, data
	mov	es, ax
	mov	ax, 1012h
	mov	bx, 0
	mov	cx, 256
	mov	dx, offset paletta
	int	10h
	mov	ax, 0a000h	;kep
	mov	es, ax
	pop	cx
	ret
palette endp
drawsprite proc		;a sprite kirajzolsa a megfelel pozcira. (maskolva)
	push	cx
	push	ax
	push	bx
	mov	bx, offset maszk
	mov	si, offset sprite	;kirajzolando sprite bal felso sarkanak kepernyobeli cime
	mov	ax, iy
	mul	xres
	add	ax, ix
	mov	di, ax
	mov	cx, 8
dcikl1:	
	mov	al, 10000000b
	mov	ah, [bx]	;1.sor-a a maszknak
dcikl2:	
	test	ah,al	;ah, s al sszeselse eredmny az ah-ban.	ezt nem ertem mit csinal
	jz	nincspont
	movsb		;mov es:[di], ds:[si]
	jmp	kovpont
nincspont:
	inc	di
	inc	si
kovpont:
	shr	al, 1
	jnc	dcikl2       ;jnc:=jump not c<>0
	add	di, xres
	sub	di, 8       ;sub==di:=di-8
	inc	bx
	loop	dcikl1
	pop	bx
	pop	ax
	pop	cx
	ret
drawsprite endp
restoreground proc		;httr visszamentse a kpernyre
	push	cx
	push	ax
	mov	si, offset array
	mov	ax, iy
	mul	xres        ;mul ax-et szorozza.
	add	ax, ix
	mov	di, ax
	mov	cx, 8
r_cikl1:
	push	cx
	mov	cx, 8
	rep	movsb       ;ciklus; ds:[si]->es:[di]; si:=si+1; di:=di+1; cx--; end ciklus amig cx<>0
	add	di, xres
	sub	di, 8
	pop	cx
	loop	r_cikl1
	pop	ax
	pop	cx
	ret
restoreground endp
saveground proc		;httr elmentse
	push	cx
	push	ax
	mov	di, offset array
	mov	ax, iy	;honnan
	mul	xres	;masolunk
	add	ax, ix
	mov	si, ax
	mov	ax, xres
	sub	ax, 8
	push	ds
	push	es
	pop	ds
	pop	es
	mov	cx, 8
s_cikl1:
	push	cx
	mov	cx,8
	rep	movsb
	add	si, ax
	pop	cx
	loop	s_cikl1
	push	ds
	push	es
	pop	ds
	pop	es
	pop	ax
	pop	cx
	ret
saveground endp
atszinezp proc		;az aktulis pontot tszinezi.
	mov	ax, iy
	add	ax, 3
	mov	bx, 320
	mul	bx
	add	ax, ix
	add	ax, 3
	mov	di, ax
	mov	bl, es:[di]
	inc	bl	;nveli a sznt
	mov	si, 27
	mov	array[si], bl
	mov	es:[di], bl
	mov	ax, ykoord
	sbb	ax, iy
	dec	ax	;ax--
	mov	cx, xkoord
	mul	cx
	add	ax, ix
	mov	di, ax
	mov	tomb[di], bl
	ret
atszinezp endp
atszinezn proc
	mov	ax, iy
	add	ax, 3
	mov	bx, 320
	mul	bx
	add	ax, ix
	add	ax, 3
	mov	di, ax
	mov	bl, es:[di]
	dec	bl	;nveli a sznt
	mov	si, 27
	mov	array[si], bl
	mov	es:[di], bl
	mov	ax, ykoord
	sbb	ax, iy
	dec	ax
	mov	cx, xkoord
	mul	cx
	add	ax, ix
	mov	di, ax
	mov	tomb[di], bl
	ret
atszinezn endp
start:
	mov	ax, data
	mov	ds, ax
	mov	ax, stack1
	mov	ss, ax
	mov	ax, 0a000h	;kep
	mov	es, ax
	mov	ax, 0013h	;
	int 	10h	;320*200*256 kpernymd belltsa.

	call	loadfile
	jc	vege2	;ha nem sikerl.
	call	palette	;aperny tpalettzsa.
;koordbeolvasas:
	mov	honnan, 18	;a file 18. bytejtl jn az x-koordina.
	call	movepointer
	mov	bx, fszam
	mov	cx, 2	;2 byte
	mov	dx, offset xkoord
	mov	ah, 3fh
	int	21h
	jmp	kov
vege2:	
	jc	vege3		;ez lehetne jmp is csak nem gondolkodtam...
kov:	
	mov	honnan, 22	;a file 22.bytejtl jn az y-koordinta.
	call	movepointer
	mov	bx, fszam
	mov	cx, 2	;2 byre
	mov	dx, offset ykoord
	mov	ah, 3fh
	int	21h
;koordbeolvasas vege
	mov	honnan, 34	;a file 34. bytejtl jn a 
	call	movepointer
	mov	bx, fszam
	mov	cx, 2	;2 byte
	mov	dx, offset hossz
	mov	ah, 3fh
	int	21h
	mov	honnan, 1078	;innen kezddik a kp.
	call	movepointer
	call	read
	call	kirajzol
	call	saveground
	call	drawsprite
keypress:	
	xor	ax, ax		;mov ax, 0
	int	16h		;olvastunk-e be a billentyzetrl?
	cmp	al, 27		;esc
	je	vege3
	cmp	al, 0
	jne	keypress
	cmp	ah, 60		;F2-save
	jz	savefile
	cmp	ah, 72		;fel kurzor
	jz	fel
	cmp	ah, 80		;le kurzor
	jz	lefele
	cmp	ah, 75		;bal kurzor
	jz	bal
	cmp	ah, 77		;jobb kurzor
	jz	jobb
	cmp	ah, 73
	jz	poz		;pgup
	cmp	ah, 81
	jz	neg1		;pgdown
	jmp	keypress
vege3:
	jmp	vege4
savefile:
	call	restoreground
	mov	honnan, 1078
	call	movepointer
	call	save
	jmp	mozgat
poz:
	call	atszinezp
	jmp	keypress
neg1:
	call	atszinezn
	jmp	keypress
fel:
	cmp	iy, 0
	jz	keypress		;tulcsorduls ellen
	call	restoreground
	dec	iy
	jmp	mozgat
lefele:
	mov	ax, yres
	sub	ax, 8		;ax-=8
	cmp	iy, ax
	jz	keypress		;tulcsorduls ellen
	call	restoreground
	inc	iy
	jmp	mozgat
bal:	
	cmp	ix, 0
	jz	nemmozgat		;tulcsorduls ellen
	call	restoreground
	dec	ix
	jmp	mozgat
jobb:	
	mov	ax, xres
	sub	ax, 8
	cmp	ix, ax
	jz	nemmozgat		;tulcsorduls ellen
	call	restoreground
	inc	ix
	jmp	mozgat
vege4:	
	jmp	vege
mozgat:	
	call	saveground
	call	drawsprite
	jmp	keypress
nemmozgat:	
	jmp	keypress
vege:	
	call	restoreground
vege1:	
	call	closefile
	mov	ah, 0
	mov	al, 03h		;karakteres kepernyo
	int	10h
	mov	ax, 4c00h
	int	21h
kod ends
end start